#ifndef __Adv_Player_H
#define __Adv_Player_H

#include "aconst.h"

//This holds the player's information.
typedef struct player_
{
	//Name of player.  You can kill this if you're not asking for
	//the player's name.
	//char Name[16];
	//Stores the room's destination room # if in a room where
	//you can type "exit."  Kill if not needed.
	//unsigned char ExitRoom;
	//Holds the player's inventory.
	unsigned char Inv[8];
	//Holds the player's score.
	unsigned short Score;
	//An array of bits to determine which associated tasks have been done.
	//You can increase its size if necessary.
	unsigned char Tasks[4];
	//The items in all the rooms
	unsigned char RoomInv [NumRooms][8];
	//Holds the information on the state of each room.
	//Disable if not needed.
	unsigned char RoomState [NumRooms];
};
//This declares the player's state.
extern struct player_ Player;

/********************************************************************/
/* Task defines, return whether task is done.                       */

//These are from my Smir 3, 1 text adventure.
//They are only here to show how to define the macro that
//returns whether the bit associated with a particular task
//is true, meaning the task was done.
/*Call from Talnon at start of game answered*/
#define taskTalnonAnswered1	(Player.Tasks[0]&1)
/*Ransom letter at Talnon's read*/
#define taskRansomRead		(Player.Tasks[0]&2)
/*Search supplies bought*/
#define taskScannersBought	(Player.Tasks[0]&4)
/*Portal to Malin open*/
#define taskPortalToMalinOpen	(Player.Tasks[0]&8)


#endif

