;
; Startup code for cc65 (C16 version)
;
; Note: The C16 is actually the Plus/4 with just 16KB of memory. So, many
; things are similar here; and, we even use the plus4.inc include file.
;

        .export         _exit
        .export         __STARTUP__ : absolute = 1      ; Mark as startup
        .import         initlib, donelib
        .import         callmain, zerobss, _main
        .import         MEMTOP, RESTOR, BSOUT, CLRCH
        .import         _getkey, _printc

        .exportzp	_i, _j, _Itm1, _CRoom, _CurPos, _CurItem, _s, _Vrb, _c
        .exportzp	_CRm, _CurRoomInv, _e, _ItemPtr, _s2

	.export		_printmsg

        .import         _printc, _printcr, _prints, _printscr, _Message
        .import         _printtok

        .include        "zeropage.inc"
        .include        "plus4.inc"

; ------------------------------------------------------------------------
; Startup code

.segment        "STARTUP"

Start:

; Switch to the second charset.

        lda     #14
        jsr     BSOUT

; Clear the BSS data.
        jsr     zerobss

; Save some system stuff; and, set up the stack.

        ;tsx
        ;stx     spsave          ; save system stk ptr

        ;sec
        ;jsr     MEMTOP          ; Get top memory
        ;cpy     #$80            ; We can only use the low 32K :-(
        ;bcc     MemOk
        ;ldy     #$80
        ;ldx     #$00
	ldx	#$00
	ldy	#$40
MemOk:  stx     sp
        sty     sp+1            ; set argument stack ptr

; Call the module constructors.

        ;jsr     initlib

; Push the command-line arguments; and, call main().

        jsr     _main ;callmain

; Call the module destructors. This is also the exit() entry.

_exit:  ;pha                     ; Save the return code on stack

	;jsr	_getkey

        ;jsr     donelib         ; Run module destructors

; Back to BASIC.

	jmp	($FFFC)
        ;rts

; ------------------------------------------------------------------------


; ------------------------------------------------------------------------

.bss

spsave: .res    1

.segment "INPUTH"
	.word	$200
.segment "TAPEH"
	.word	$332
.segment "BSTKH"
	.word	$065E
.segment "ZP2H"
	.word	$0032

.zeropage
_i:		.res	1
_j:		.res	1
_Itm1:		.res	1
_CRoom:		.res	1
_CurPos:	.res	1
_CurItem:	.res	1
_s:		.res	2
_Vrb:		.res	1
_c:		.res	1
_CRm:		.res	2
_CurRoomInv:	.res	2
_e:		.res	1
_ItemPtr:	.res	2
_s2:		.res	2

.segment	"INPUTCO"
_printmsg:
	asl
	tax
	lda	_Message,x
	pha
	lda	_Message+1,x
	tax
	pla
	;jsr	_printtok
	jmp	_printscr
